stages:
  - prepare
  - lintDebug
  - assembleDebug
  - test


# Make gradlew executable
prepare:
  interruptible: true
  stage: build
  script:
    - chmod +x ./gradlew

# Basic android and gradle stuff
# Check linting
lintDebug:
  interruptible: true
  stage: build
  script:
    - ./gradlew -Pci --console=plain :app:lintDebug -PbuildDir=lint

# Make Project
assembleDebug:
  interruptible: true
  stage: build
  script:
    - ./gradlew assembleDebug
  artifacts:
    paths:
      - app/build/outputs/

# Run tests
test:
  interruptible: true
  stage: test
  image: openjdk:8-jdk
  only:
    - master
  coverage: /Lines\s*:\s*(\d+.?\d*)%/
  script:
    - ./gradlew -Pci --console=plain :app:test
  artifacts:
    when: always
    reports:
      jacoco:
        - ./app/build/reports/jacoco/jacocoReport/jacocoReport.xml

# Run all tests, if any fails, interrupt the pipeline(fail it)
#debugTests:
#  interruptible: true
#  stage: test
#  script:
#    - ./gradlew -Pci --console=plain :app:test
